#!/usr/bin/python
#coding=utf-8
#本范例在windows7 + python 2.7.12测试通过
#测试方法,命令行下执行: "C:\Python27\python.exe" APIStore.py
import sys
import collections
import httplib
import urllib
import random
import io

'''
在python2.x中,字符串有两种,都继承自basestring,一种是类似byte的字节流(类似C的char数组),查看类型type为str,一种是unicode对象,查看类型type为unicode.
字节流是编码后的数据流,本身不含编码类型数据;unicode对象则是含有编码类型数据的原始字符串对象
字节流到unicode对象,是解码decode;unicode对象到字节流,是编码encode
在源码里写的字符串,python是将其视为byte字节流的,它会以源码头部的#coding=xxx所定义的 编码类型,将字符串encode为字节流后保存在内存里;而如果在前面加上u字母,则会被认为是unicode对象
'''
#把字节流由源码文件的编码(UTF-8)修改为控制台输出的编码;先解码字节流到unicode对象,然后再编码成输出编码字节流是为了避免内容中有编码中没有的字符而报错
def changeToSystemCode(str):
    encoding = sys.stdout.encoding;
    str = str.decode('utf-8','replace').encode(encoding,'replace');		#把字符串按照系统编码然后再解码(过滤其中的无法编码的字符,防止print报错)
    return str;



#POST方式请求(推荐)
#host string 主机名
#path string 访问路径
#param_dict OrderedDict 附加参数
def requestPost(host,path,param_dict):
    param_str = urllib.urlencode(param_dict);
    print changeToSystemCode('HTTP的POST请求:' + host + path + '?' + param_str);

    conn = httplib.HTTPConnection(host);
    headers = {"Content-type": "application/x-www-form-urlencoded", "Accept": "text/plain"}
    conn.request("POST", path,param_str,headers);
    response = conn.getresponse();
    #print response.status, response.reason;
    data = response.read();		#返回数据
    conn.close();		#关闭链接
    print changeToSystemCode('POST方式返回结果:' + data);
    return;

#GET方式请求
#host string 主机名
#path string 访问路径
#param_dict OrderedDict 附加参数
def requestGet(host,path,param_dict):
    param_str = urllib.urlencode(param_dict);
    print changeToSystemCode('HTTP的GET请求:' + host + path + '?' + param_str);

    conn = httplib.HTTPConnection(host);
    if not param_str is None and len(param_str) > 0:		#有附加参数加加上附加参数
     path = path + "?" + param_str;

    conn.request("GET", path);
    response = conn.getresponse();
    #print response.status, response.reason;
    data = response.read();		#返回数据
    conn.close();		#关闭链接
    print changeToSystemCode('GET方式返回结果:' + data);
    return;

    
#获取内容
def getContent(type='POST'):
    
    host = 'www.apistore.cn';		#主机名
    path = '/api/a1';		#访问路径
   
    dict = collections.OrderedDict();		#有序字典
    dict['key'] = '您申请的key,在会员中心->我的数据->对应数据的上方';
dict['cardNo'] = '5110111';
dict['realName'] = '张三';
dict['information'] = '';

    

    if type == 'GET':            # GET方式请求
     requestGet(host,path,dict);    
    else:                        #POST方式请求(推荐)
     requestPost(host,path,dict); 
    return;

    

print changeToSystemCode("Hello, APIStore");
getContent('POST');		